K = 4
# We only need the first four features...
pca = PCA(n_components=K)
V_k = pca.fit_transform(v_k)
sig = np.sqrt(pca.explained_variance_)

# Let's retrieve the four main directions:
modes = []
for i in range(K) :
    vec = np.zeros(K)
    vec[i] = 1.
    mode   = tensor( sig[i]*pca.inverse_transform( vec ))
    mode   = 2 * mode.float().view(-1,2) # inflate a little bit...
    modes.append( [ exp(mean, mode), exp(mean, -mode) ] )

# Display
plt.figure(figsize=(10,10))
for i, (p, m) in enumerate(modes) :
    plt.subplot(2,2,i+1)
    plot_worms(mean,"red")
    plot_worms(p,   "blue")
    plot_worms(m,   "blue")
    plt.axis([-.5,.5,-.5,.5])
plt.show()
